dnl
dnl Select host CPU.
dnl
AC_DEFUN(AC_ENABLE_HOST_CPU, [
host_cpu_opt=
AC_ARG_ENABLE(host_cpu,
[--enable-host-cpu=CPU		Build with optimizations for CPU],
[ case x"${enable_host_cpu}" in
  xyes|xno)
    AC_MSG_WARN([--enable-host-cpu takes a CPU name argument])
    ;;
  *)
    host_cpu_opt="${enable_host_cpu}"
    ;;
  esac
])
AC_SUBST(host_cpu_opt)

changequote(<<,>>)
case "${host_cpu}" in
i[34567]86)
  host_arch_compiler_frag="${srcdir}/config/mk/ia32-${host_cc}.mk"
  ;;
powerpc*|rs6000)
  host_arch_compiler_frag="${srcdir}/config/mk/powerpc-${host_cc}.mk"
  ;;
arm*)
  host_arch_compiler_frag="${srcdir}/config/mk/arm-${host_cc}.mk"
  ;;
*)
  host_arch_compiler_frag="${srcdir}/config/mk/${host_cpu}-${host_cc}.mk"
  ;;
esac

if test ! -f "${host_arch_compiler_frag}"; then
  host_arch_compiler_frag="${srcdir}/config/mk/empty.mk"
fi
changequote([,])

AC_SUBST_FILE(host_arch_compiler_frag)])

# arch-tag: 36340bc6-59eb-4278-9e2c-b285b07ee844
