.SUFFIXES:
.SUFFIXES: .c .cxx .h .S .o .a .d .bd

vpath
vpath %.c   $(srcdir)
vpath %.cxx $(srcdir)
vpath %.S   $(srcdir)
vpath %.y   $(srcdir)

$(objsubdir)%.o : %.c
	$(_CC) -c $(_CFLAGS) $(_CPPFLAGS) -o $@ $<

$(objsubdir)%.S : %.c
	$(_CC) -S $(_CFLAGS) $(_CPPFLAGS) -o $@ $<

$(objsubdir)%.o : %.cxx
	$(_CXX) -c $(_CXXFLAGS) $(_CPPFLAGS) -o $@ $<

$(objsubdir)%.S : %.cxx
	$(_CXX) -S $(_CXXFLAGS) $(_CPPFLAGS) -o $@ $<

$(objsubdir)%.d : %.c
	-$(MKDIR) $(dir $@)
	$(_CPP) $(_CPPFLAGS) -M -MG $< | sed -e "s#.*:#$(@:%.d=%.o):#g" > $@

$(objsubdir)%.d : %.cxx
	-$(MKDIR) $(dir $@)
	$(_CPP) $(_CPPFLAGS) -M -MG $< | sed -e "s#.*:#$(@:%.d=%.o):#g" > $@

$(objsubdir)%.c $(objsubdir)%.h : %.y
	$(YACC) $(YFLAGS) -o $(objsubdir)$*.c $<

all::

clean::
	$(RM) *~

distclean:: clean
	$(RM) Makefile

#
# Define rules for making in subdirectories
#
ifneq ($(subdirs),)

all:: $(subdirs)

$(subdirs):
	$(MAKE) -C $@

subdirs-clean = $(subdirs:%=%-clean)

$(subdirs-clean) :
	$(MAKE) -C $(@:%-clean=%) clean

clean:: $(subdirs-clean)

subdirs-distclean = $(subdirs:%=%-distclean)

$(subdirs-distclean) :
	$(MAKE) -C $(@:%-distclean=%) distclean

distclean:: $(subdirs-distclean)

.PHONY: $(subdirs) $(subdirs-clean) $(subdirs-distclean)

endif

#
# Define rules for making libraries
#
ifneq ($(libname),)

all:: $(LIBDIR)$(libname)

clean::
	$(RM) $(LIBDIR)$(libname)

$(LIBDIR)$(libname) : $(OBJS)
	$(RM) $@
	$(_AR) ru $@ $(OBJS)
	$(_RANLIB) $@
endif

#
# Define rule for cleaning object files
#
ifneq ($(OBJS),)
clean::
	$(RM) $(OBJS)
endif

#
# Define rules for making dependencies
#
ifneq ($(DEPS),)
clean::
	$(RM) $(DEPS)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
-include $(DEPS)
endif
endif
endif

#
# Variable "rules"
#
libnames = $(argv:%=$(top_builddir)/lib/lib%.a)
ldadd    = -L$(top_builddir)/lib $(argv:%=-l%)

.PHONY: all clean distclean

# arch-tag: 92875368-e5d9-42e6-a758-445c4c3fb275
